// MIDI Humanizer GUI Prototype 2
// Jacob Peck
// Team La-a
// 20111018

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class GUIProto2 {
  private static String currentPane = "0";
  private static int currentPaneIndex = 0;
  private static int lastPaneIndex = 5;
  private static JPanel cardpanel;
  
  
  private static void createAndShowGUI() {
    // initialize the frame
    JFrame frame = new JFrame("MIDI Humanizer GUI Prototype 2");
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    frame.setIconImage(new ImageIcon("icon.png").getImage());
    frame.setSize(600,450);
    
    // cards (wizard pages)
    JPanel card0 = new JPanel();
    JLabel card0label = new JLabel("This is the Welcome card");
    card0.add(card0label);
    
    JPanel card1 = new JPanel();
    JLabel card1label = new JLabel("This is the file selection card");
    card1.add(card1label);
    
    JPanel card2 = new JPanel();
    JLabel card2label = new JLabel("This is the profile selection card");
    card2.add(card2label);
    
    JPanel card3 = new JPanel();
    JLabel card3label = new JLabel("This is the parameter selection card");
    card3.add(card3label);
    
    JPanel card4 = new JPanel();
    JLabel card4label = new JLabel("This is the preview card");
    card4.add(card4label);
    
    JPanel card5 = new JPanel();
    JLabel card5label = new JLabel("This is the save card");
    card5.add(card5label);
    
    // cards (help pages) index = prevpage + 10
    JPanel card10 = new JPanel();
    JLabel card10label = new JLabel("This is help for the Welcome card.");
    card10.add(card10label);
    
    JPanel card11 = new JPanel();
    JLabel card11label = new JLabel("This is help for the file selection card.");
    card11.add(card11label);
    
    JPanel card12 = new JPanel();
    JLabel card12label = new JLabel("This is the help for the profile selection card");
    card12.add(card12label);
    
    JPanel card13 = new JPanel();
    JLabel card13label = new JLabel("This is the help for the parameter selection card");
    card13.add(card13label);
    
    JPanel card14 = new JPanel();
    JLabel card14label = new JLabel("This is the help for the preview card");
    card14.add(card14label);
    
    JPanel card15 = new JPanel();
    JLabel card15label = new JLabel("This is the help for the save card");
    card15.add(card15label);
    
    
    // cardlayout
    cardpanel = new JPanel(new CardLayout());
    cardpanel.add(card0,"0");
    cardpanel.add(card1,"1");
    cardpanel.add(card2,"2");
    cardpanel.add(card3,"3");
    cardpanel.add(card4,"4");
    cardpanel.add(card5,"5");
    cardpanel.add(card10,"10");
    cardpanel.add(card11,"11");
    cardpanel.add(card12,"12");
    cardpanel.add(card13,"13");
    cardpanel.add(card14,"14");
    cardpanel.add(card15,"15");
    
    // control panel (help, previous, next)
    JPanel controls = new JPanel();
    final JButton help = new JButton("Help");
    final JButton next = new JButton("Next-->");
    final JButton prev = new JButton("<--Previous");
    prev.setEnabled(false);
    controls.add(help);
    controls.add(prev);
    controls.add(next);
    
    
    
    // action listeners
    next.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        CardLayout cl = (CardLayout)(cardpanel.getLayout());
        currentPaneIndex++;
        if (currentPaneIndex > lastPaneIndex) currentPaneIndex = lastPaneIndex;
        currentPane = Integer.toString(currentPaneIndex);
        if (currentPaneIndex >= lastPaneIndex) { // if last pane, or in help
          next.setEnabled(false);
          prev.setEnabled(true);
        } else {
          next.setEnabled(true);
          if (currentPaneIndex > 0) prev.setEnabled(true);
          else prev.setEnabled(false);
        }
        help.setEnabled(true);
        cl.show(cardpanel, currentPane);
      }
    });
    
    prev.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        CardLayout cl = (CardLayout)(cardpanel.getLayout());
        if (currentPaneIndex <= lastPaneIndex)
          currentPaneIndex--;
        else
          currentPaneIndex -= 10;
        if (currentPaneIndex < 0) currentPaneIndex = 0;
        currentPane = Integer.toString(currentPaneIndex);
        if (currentPaneIndex <= 0) { // if first pane
          prev.setEnabled(false);
          next.setEnabled(true);
        } else if (currentPaneIndex > lastPaneIndex) { // help pane
          next.setEnabled(false);
          prev.setEnabled(true);
        } else {
          prev.setEnabled(true);
          if (currentPaneIndex < lastPaneIndex) next.setEnabled(true);
          else next.setEnabled(false);
        }
        help.setEnabled(true);
        cl.show(cardpanel, currentPane);
      }
    });

    help.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        CardLayout cl = (CardLayout)(cardpanel.getLayout());
        currentPaneIndex += 10;
        if (currentPaneIndex >= lastPaneIndex+10) currentPaneIndex = lastPaneIndex+10;
        currentPane = Integer.toString(currentPaneIndex);
        // help pane
        help.setEnabled(false);
        next.setEnabled(false);
        prev.setEnabled(true);
        cl.show(cardpanel, currentPane);
      }
    });
    
    // build the gui, finally
    frame.getContentPane().add(cardpanel, BorderLayout.CENTER);
    frame.getContentPane().add(controls, BorderLayout.SOUTH);
    
    
    // display the frame
    //frame.pack();
    frame.setVisible(true);
  }
  
  static public void main(String[] args) {
    // Use the system's Look and Feel
    try {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    } catch (UnsupportedLookAndFeelException ex) {
      ex.printStackTrace();
    } catch (IllegalAccessException ex) {
      ex.printStackTrace();
    } catch (InstantiationException ex) {
      ex.printStackTrace();
    } catch (ClassNotFoundException ex) {
      ex.printStackTrace();
    }
    
    javax.swing.SwingUtilities.invokeLater(new Runnable() {
      public void run() {
        createAndShowGUI();
      }
    });
  }
}
